<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/flate2-1.0.24/src/lib.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>lib.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../flate2/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../flate2/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../flate2/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
</pre><pre class="rust"><code><span class="doccomment">//! A DEFLATE-based stream compression/decompression library</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! This library provides support for compression and decompression of</span>
<span class="doccomment">//! DEFLATE-based streams:</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! * the DEFLATE format itself</span>
<span class="doccomment">//! * the zlib format</span>
<span class="doccomment">//! * gzip</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! These three formats are all closely related and largely only differ in their</span>
<span class="doccomment">//! headers/footers. This crate has three types in each submodule for dealing</span>
<span class="doccomment">//! with these three formats.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! # Implementation</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! In addition to supporting three formats, this crate supports several different</span>
<span class="doccomment">//! backends, controlled through this crate&#39;s features:</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! * `default`, or `rust_backend` - this implementation uses the `miniz_oxide`</span>
<span class="doccomment">//!   crate which is a port of `miniz.c` (below) to Rust. This feature does not</span>
<span class="doccomment">//!   require a C compiler and only requires Rust code.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! * `zlib` - this feature will enable linking against the `libz` library, typically found on most</span>
<span class="doccomment">//!   Linux systems by default. If the library isn&#39;t found to already be on the system it will be</span>
<span class="doccomment">//!   compiled from source (this is a C library).</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! There&#39;s various tradeoffs associated with each implementation, but in general you probably</span>
<span class="doccomment">//! won&#39;t have to tweak the defaults. The default choice is selected to avoid the need for a C</span>
<span class="doccomment">//! compiler at build time. `zlib-ng-compat` is useful if you&#39;re using zlib for compatibility but</span>
<span class="doccomment">//! want performance via zlib-ng&#39;s zlib-compat mode. `zlib` is useful if something else in your</span>
<span class="doccomment">//! dependencies links the original zlib so you cannot use zlib-ng-compat. The compression ratios</span>
<span class="doccomment">//! and performance of each of these feature should be roughly comparable, but you&#39;ll likely want</span>
<span class="doccomment">//! to run your own tests if you&#39;re curious about the performance.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! # Organization</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! This crate consists mainly of three modules, [`read`], [`write`], and</span>
<span class="doccomment">//! [`bufread`]. Each module contains a number of types used to encode and</span>
<span class="doccomment">//! decode various streams of data.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! All types in the [`write`] module work on instances of [`Write`][write],</span>
<span class="doccomment">//! whereas all types in the [`read`] module work on instances of</span>
<span class="doccomment">//! [`Read`][read] and [`bufread`] works with [`BufRead`][bufread]. If you</span>
<span class="doccomment">//! are decoding directly from a `&amp;[u8]`, use the [`bufread`] types.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ```</span>
<span class="doccomment">//! use flate2::write::GzEncoder;</span>
<span class="doccomment">//! use flate2::Compression;</span>
<span class="doccomment">//! use std::io;</span>
<span class="doccomment">//! use std::io::prelude::*;</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! # fn main() { let _ = run(); }</span>
<span class="doccomment">//! # fn run() -&gt; io::Result&lt;()&gt; {</span>
<span class="doccomment">//! let mut encoder = GzEncoder::new(Vec::new(), Compression::default());</span>
<span class="doccomment">//! encoder.write_all(b&quot;Example&quot;)?;</span>
<span class="doccomment">//! # Ok(())</span>
<span class="doccomment">//! # }</span>
<span class="doccomment">//! ```</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Other various types are provided at the top-level of the crate for</span>
<span class="doccomment">//! management and dealing with encoders/decoders. Also note that types which</span>
<span class="doccomment">//! operate over a specific trait often implement the mirroring trait as well.</span>
<span class="doccomment">//! For example a `flate2::read::DeflateDecoder&lt;T&gt;` *also* implements the</span>
<span class="doccomment">//! `Write` trait if `T: Write`. That is, the &quot;dual trait&quot; is forwarded directly</span>
<span class="doccomment">//! to the underlying object if available.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! [`read`]: read/index.html</span>
<span class="doccomment">//! [`bufread`]: bufread/index.html</span>
<span class="doccomment">//! [`write`]: write/index.html</span>
<span class="doccomment">//! [read]: https://doc.rust-lang.org/std/io/trait.Read.html</span>
<span class="doccomment">//! [write]: https://doc.rust-lang.org/std/io/trait.Write.html</span>
<span class="doccomment">//! [bufread]: https://doc.rust-lang.org/std/io/trait.BufRead.html</span>
<span class="attribute">#![<span class="ident">doc</span>(<span class="ident">html_root_url</span> <span class="op">=</span> <span class="string">&quot;https://docs.rs/flate2/0.2&quot;</span>)]</span>
<span class="attribute">#![<span class="ident">deny</span>(<span class="ident">missing_docs</span>)]</span>
<span class="attribute">#![<span class="ident">deny</span>(<span class="ident">missing_debug_implementations</span>)]</span>
<span class="attribute">#![<span class="ident">allow</span>(<span class="ident">trivial_numeric_casts</span>)]</span>
<span class="attribute">#![<span class="ident">cfg_attr</span>(<span class="ident">test</span>, <span class="ident">deny</span>(<span class="ident">warnings</span>))]</span>

<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::crc</span>::{<span class="ident">Crc</span>, <span class="ident">CrcReader</span>, <span class="ident">CrcWriter</span>};
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::gz::GzBuilder</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::gz::GzHeader</span>;
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::mem</span>::{<span class="ident">Compress</span>, <span class="ident">CompressError</span>, <span class="ident">Decompress</span>, <span class="ident">DecompressError</span>, <span class="ident">Status</span>};
<span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::mem</span>::{<span class="ident">FlushCompress</span>, <span class="ident">FlushDecompress</span>};

<span class="kw">mod</span> <span class="ident">bufreader</span>;
<span class="kw">mod</span> <span class="ident">crc</span>;
<span class="kw">mod</span> <span class="ident">deflate</span>;
<span class="kw">mod</span> <span class="ident">ffi</span>;
<span class="kw">mod</span> <span class="ident">gz</span>;
<span class="kw">mod</span> <span class="ident">mem</span>;
<span class="kw">mod</span> <span class="ident">zio</span>;
<span class="kw">mod</span> <span class="ident">zlib</span>;

<span class="doccomment">/// Types which operate over [`Read`] streams, both encoders and decoders for</span>
<span class="doccomment">/// various formats.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// [`Read`]: https://doc.rust-lang.org/std/io/trait.Read.html</span>
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">read</span> {
    <span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::deflate::read::DeflateDecoder</span>;
    <span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::deflate::read::DeflateEncoder</span>;
    <span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::gz::read::GzDecoder</span>;
    <span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::gz::read::GzEncoder</span>;
    <span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::gz::read::MultiGzDecoder</span>;
    <span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::zlib::read::ZlibDecoder</span>;
    <span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::zlib::read::ZlibEncoder</span>;
}

<span class="doccomment">/// Types which operate over [`Write`] streams, both encoders and decoders for</span>
<span class="doccomment">/// various formats.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// [`Write`]: https://doc.rust-lang.org/std/io/trait.Write.html</span>
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">write</span> {
    <span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::deflate::write::DeflateDecoder</span>;
    <span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::deflate::write::DeflateEncoder</span>;
    <span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::gz::write::GzDecoder</span>;
    <span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::gz::write::GzEncoder</span>;
    <span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::zlib::write::ZlibDecoder</span>;
    <span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::zlib::write::ZlibEncoder</span>;
}

<span class="doccomment">/// Types which operate over [`BufRead`] streams, both encoders and decoders for</span>
<span class="doccomment">/// various formats.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// [`BufRead`]: https://doc.rust-lang.org/std/io/trait.BufRead.html</span>
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">bufread</span> {
    <span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::deflate::bufread::DeflateDecoder</span>;
    <span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::deflate::bufread::DeflateEncoder</span>;
    <span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::gz::bufread::GzDecoder</span>;
    <span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::gz::bufread::GzEncoder</span>;
    <span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::gz::bufread::MultiGzDecoder</span>;
    <span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::zlib::bufread::ZlibDecoder</span>;
    <span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::zlib::bufread::ZlibEncoder</span>;
}

<span class="kw">fn</span> <span class="ident">_assert_send_sync</span>() {
    <span class="kw">fn</span> <span class="ident">_assert_send_sync</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">Send</span> <span class="op">+</span> <span class="ident">Sync</span><span class="op">&gt;</span>() {}

    <span class="ident">_assert_send_sync</span>::<span class="op">&lt;</span><span class="ident">read::DeflateEncoder</span><span class="op">&lt;</span><span class="kw-2">&amp;</span>[<span class="ident">u8</span>]<span class="op">&gt;</span><span class="op">&gt;</span>();
    <span class="ident">_assert_send_sync</span>::<span class="op">&lt;</span><span class="ident">read::DeflateDecoder</span><span class="op">&lt;</span><span class="kw-2">&amp;</span>[<span class="ident">u8</span>]<span class="op">&gt;</span><span class="op">&gt;</span>();
    <span class="ident">_assert_send_sync</span>::<span class="op">&lt;</span><span class="ident">read::ZlibEncoder</span><span class="op">&lt;</span><span class="kw-2">&amp;</span>[<span class="ident">u8</span>]<span class="op">&gt;</span><span class="op">&gt;</span>();
    <span class="ident">_assert_send_sync</span>::<span class="op">&lt;</span><span class="ident">read::ZlibDecoder</span><span class="op">&lt;</span><span class="kw-2">&amp;</span>[<span class="ident">u8</span>]<span class="op">&gt;</span><span class="op">&gt;</span>();
    <span class="ident">_assert_send_sync</span>::<span class="op">&lt;</span><span class="ident">read::GzEncoder</span><span class="op">&lt;</span><span class="kw-2">&amp;</span>[<span class="ident">u8</span>]<span class="op">&gt;</span><span class="op">&gt;</span>();
    <span class="ident">_assert_send_sync</span>::<span class="op">&lt;</span><span class="ident">read::GzDecoder</span><span class="op">&lt;</span><span class="kw-2">&amp;</span>[<span class="ident">u8</span>]<span class="op">&gt;</span><span class="op">&gt;</span>();
    <span class="ident">_assert_send_sync</span>::<span class="op">&lt;</span><span class="ident">read::MultiGzDecoder</span><span class="op">&lt;</span><span class="kw-2">&amp;</span>[<span class="ident">u8</span>]<span class="op">&gt;</span><span class="op">&gt;</span>();
    <span class="ident">_assert_send_sync</span>::<span class="op">&lt;</span><span class="ident">write::DeflateEncoder</span><span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span><span class="op">&gt;</span><span class="op">&gt;</span>();
    <span class="ident">_assert_send_sync</span>::<span class="op">&lt;</span><span class="ident">write::DeflateDecoder</span><span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span><span class="op">&gt;</span><span class="op">&gt;</span>();
    <span class="ident">_assert_send_sync</span>::<span class="op">&lt;</span><span class="ident">write::ZlibEncoder</span><span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span><span class="op">&gt;</span><span class="op">&gt;</span>();
    <span class="ident">_assert_send_sync</span>::<span class="op">&lt;</span><span class="ident">write::ZlibDecoder</span><span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span><span class="op">&gt;</span><span class="op">&gt;</span>();
    <span class="ident">_assert_send_sync</span>::<span class="op">&lt;</span><span class="ident">write::GzEncoder</span><span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span><span class="op">&gt;</span><span class="op">&gt;</span>();
    <span class="ident">_assert_send_sync</span>::<span class="op">&lt;</span><span class="ident">write::GzDecoder</span><span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span><span class="op">&gt;</span><span class="op">&gt;</span>();
}

<span class="doccomment">/// When compressing data, the compression level can be specified by a value in</span>
<span class="doccomment">/// this enum.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Copy</span>, <span class="ident">Clone</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Compression</span>(<span class="ident">u32</span>);

<span class="kw">impl</span> <span class="ident">Compression</span> {
    <span class="doccomment">/// Creates a new description of the compression level with an explicitly</span>
    <span class="doccomment">/// specified integer.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The integer here is typically on a scale of 0-9 where 0 means &quot;no</span>
    <span class="doccomment">/// compression&quot; and 9 means &quot;take as long as you&#39;d like&quot;.</span>
    <span class="kw">pub</span> <span class="kw">const</span> <span class="kw">fn</span> <span class="ident">new</span>(<span class="ident">level</span>: <span class="ident">u32</span>) -&gt; <span class="ident">Compression</span> {
        <span class="ident">Compression</span>(<span class="ident">level</span>)
    }

    <span class="doccomment">/// No compression is to be performed, this may actually inflate data</span>
    <span class="doccomment">/// slightly when encoding.</span>
    <span class="kw">pub</span> <span class="kw">const</span> <span class="kw">fn</span> <span class="ident">none</span>() -&gt; <span class="ident">Compression</span> {
        <span class="ident">Compression</span>(<span class="number">0</span>)
    }

    <span class="doccomment">/// Optimize for the best speed of encoding.</span>
    <span class="kw">pub</span> <span class="kw">const</span> <span class="kw">fn</span> <span class="ident">fast</span>() -&gt; <span class="ident">Compression</span> {
        <span class="ident">Compression</span>(<span class="number">1</span>)
    }

    <span class="doccomment">/// Optimize for the size of data being encoded.</span>
    <span class="kw">pub</span> <span class="kw">const</span> <span class="kw">fn</span> <span class="ident">best</span>() -&gt; <span class="ident">Compression</span> {
        <span class="ident">Compression</span>(<span class="number">9</span>)
    }

    <span class="doccomment">/// Returns an integer representing the compression level, typically on a</span>
    <span class="doccomment">/// scale of 0-9</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">level</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">u32</span> {
        <span class="self">self</span>.<span class="number">0</span>
    }
}

<span class="kw">impl</span> <span class="ident">Default</span> <span class="kw">for</span> <span class="ident">Compression</span> {
    <span class="kw">fn</span> <span class="ident">default</span>() -&gt; <span class="ident">Compression</span> {
        <span class="ident">Compression</span>(<span class="number">6</span>)
    }
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">test</span>)]</span>
<span class="kw">fn</span> <span class="ident">random_bytes</span>() -&gt; <span class="kw">impl</span> <span class="ident">Iterator</span><span class="op">&lt;</span><span class="ident">Item</span> <span class="op">=</span> <span class="ident">u8</span><span class="op">&gt;</span> {
    <span class="kw">use</span> <span class="ident">rand::Rng</span>;
    <span class="kw">use</span> <span class="ident">std::iter</span>;

    <span class="ident">iter::repeat</span>(()).<span class="ident">map</span>(<span class="op">|</span><span class="kw">_</span><span class="op">|</span> <span class="ident">rand::thread_rng</span>().<span class="ident">gen</span>())
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="flate2" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>